searchNodes=[{"doc":"","ref":"SquidWeb.html","title":"SquidWeb","type":"module"},{"doc":"Creates the dynamic router.","ref":"SquidWeb.html#create_dynamic_router/0","title":"SquidWeb.create_dynamic_router/0","type":"function"},{"doc":"Return registered routers.","ref":"SquidWeb.html#registered_routers/0","title":"SquidWeb.registered_routers/0","type":"function"},{"doc":"Endpoint helper to import everthing needs as Phoenix.Endpoint does. Before using this module, you should add the following configuration: config :your_tentacle , :squid , pubsub_server : YourPubSub , endpoint : ShellWeb.Endpoint The specified app should be the one that defined generic phoenix things such as the PubSub server. Examples defmodule TentacleWeb.Endpoint do use SquidWeb.Endpoint , otp_app : :your_tentacle end","ref":"SquidWeb.Endpoint.html","title":"SquidWeb.Endpoint","type":"module"},{"doc":"The main purpose of the HeadRouter is to dispatch requests and act as a proxy. We highly recommend to not use it in your code.","ref":"SquidWeb.HeadRouter.html","title":"SquidWeb.HeadRouter","type":"module"},{"doc":"","ref":"SquidWeb.HeadRouter.html#call/2","title":"SquidWeb.HeadRouter.call/2","type":"function"},{"doc":"","ref":"SquidWeb.HeadRouter.html#init/1","title":"SquidWeb.HeadRouter.init/1","type":"function"},{"doc":"Partials are HTML snippets that squid can render according to their priority. Partials are useful to build navigation elements such as menus from your head app (the one that includes the squid router) by delegating the business logic to other apps. Quickstart # in apps/tentacle_a/config/config.exs config :tentacle_a , :squid , partials : %{ greetings_builder : { TentacleA.Greetings , priority : 1 } } # in app/tentacle_a/lib/tentacle_a_web/greetings.ex defmodule TentacleA.Greetings do @behaviour SquidWeb.Partial def render ( assigns ) do ~H&quot;&quot;&quot; &lt;div&gt;Hello &lt;%= @user_name %&gt; from tentacle A&lt;/div&gt; &quot;&quot;&quot; end end # in apps/tentacle_b/config/config.exs config :tentacle_b , :squid , partials : %{ greetings_builder : { TentacleB.Greetings , priority : 2 } } # in app/tentacle_b/lib/tentacle_b_web/greetings.ex defmodule TentacleB.Greetings do @behaviour SquidWeb.Partial def render ( assigns ) , do : ~H&quot;&quot;&quot; &lt;div&gt;Hello &lt;%= @user_name %&gt; from tentacle B&lt;/div&gt; &quot;&quot;&quot; end end Then in your page html &lt; SquidWeb.Partial . render partial = { :greetings_builder } user_name = &quot;Squid&#39;s King&quot; / &gt; This will generate the following html &quot;&quot;&quot; &lt;div&gt;Hello Squid&#39;s King from tentacle B&lt;/div&gt; &lt;div&gt;Hello Squid&#39;s King from tentacle A&lt;/div&gt; &quot;&quot;&quot; Priorities The priority defines the order that your partials must be rendered. Partials with higher priority will be rendered first. A priority could be any interger or float values.","ref":"SquidWeb.Partial.html","title":"SquidWeb.Partial","type":"behaviour"},{"doc":"","ref":"SquidWeb.Partial.html#preload_partials/0","title":"SquidWeb.Partial.preload_partials/0","type":"function"},{"doc":"","ref":"SquidWeb.Partial.html#render/1","title":"SquidWeb.Partial.render/1","type":"function"},{"doc":"","ref":"SquidWeb.Partial.html#c:render/1","title":"SquidWeb.Partial.render/1","type":"callback"},{"doc":"Router helper to forward request to tentacle. Configurations # tentacle/config/config.exs config :squid , scopes : admin : prefix : &quot;/admin&quot; prefixed_tentacle : prefix : &quot;/{{tentacle_name}}/api&quot; {{tentacle_name}} is a reserved keyword that will be replace with your tentacle name (also know as the otp app). The app's name will be formated to kebab case. Using the previous example, an app my_app with a prefixed_tentacle squid's scope will generate a phoenix scope prefiexed by /my-app/api . You could also add specified configuration by env # tentacles/config/prod.exs config :squid , scopes : dev : disable : true Examples defmodule MyTentacleWeb.Router do use SquidWeb.Router , otp_app : :my_tentacle squid_scope &quot;/resources&quot; do get &quot;/action&quot; , MyTentacleWeb.MyResourceController , :index end squid_scope &quot;/resources&quot; , as : :admin do get &quot;/action&quot; , MyTentacleWeb.MyResourceAdminController , :index end squid_scope &quot;/resources/dev&quot; , as : :dev do get &quot;/action&quot; , MyTentacleWeb.MyResourceController , :debug end end With the configuration define in the previous chapter, this will generate followings path: /resources/action /admin/resources/action /resources/dev/action Those path could be generate by your router's helper (as phoenix does) iex&gt; MyTentacleWeb.Router.Helpers . custom_path ( conn , :index ) &quot;/resources/action&quot; iex&gt; MyTentacleWeb.Router.Helpers . admin_custom_path ( conn , :index ) &quot;/admin/resources/action&quot;","ref":"SquidWeb.Router.html","title":"SquidWeb.Router","type":"module"},{"doc":"Helper to create a tentacle router. Example use SquidWeb.Router , otp_app : :my_tentacle squid_scope &quot;/my-tentacle-prefix&quot; do get &quot;/page&quot; , MyTentacleWeb.PageController , :index end See squid_scope/3 for more informations.","ref":"SquidWeb.Router.html#__using__/1","title":"SquidWeb.Router.__using__/1","type":"macro"},{"doc":"","ref":"SquidWeb.Router.html#create_dynamic_router/1","title":"SquidWeb.Router.create_dynamic_router/1","type":"function"},{"doc":"Helper to create a tentacle pipeline. Examples use SquidWeb.Router , otp_app : :my_tentacle squid_scope &quot;/my-tentacle&quot; do pipe_through :my_tentacle_api # your actions, phoenix scopes ... end squid_pipeline :my_tentacle_api do plug :your_function end def your_function ( conn , _opts ) do # Do what ever you want conn end Limitations Currently we don't fully support plug pipe_through. If you want to pipe_through a function, you should write an explicit function name as you can see in the next example. Otherwise, if multiples tentacles router defined the same function name, you'll have a compiled error. use SquidWeb.Router , otp_app : :my_tentacle squid_scope &quot;/my-tentacle&quot; do scope &quot;/&quot; do pipe_through :my_tentacle_function_name # your actions, phoenix scopes ... end def my_tentacle_function_name ( conn , _opts ) do # Do what ever you want conn end end","ref":"SquidWeb.Router.html#squid_pipeline/2","title":"SquidWeb.Router.squid_pipeline/2","type":"macro"},{"doc":"Helper to create a tentacle router. Examples use SquidWeb.Router , otp_app : :my_tentacle squid_scope &quot;/my-tentacle-prefix&quot; do get &quot;/page&quot; , MyTentacleWeb.PageController , :index end This will register following helpers: SquidWeb.HeadRouter.Helpers.tentacle_app_page_path/2 and MyTentacleWeb.Router.Helpers.page_path/2 You could also create routes under a scope such as admin . squid_scope &quot;/my-tentacle-prefix&quot; , scope : :admin do get &quot;/users&quot; , MyTentacleWeb.UserController , :index end Options scope define the scope of the router such as api , web , admin . (default: :default )","ref":"SquidWeb.Router.html#squid_scope/3","title":"SquidWeb.Router.squid_scope/3","type":"macro"},{"doc":"","ref":"SquidWeb.Router.html#t:ast/0","title":"SquidWeb.Router.ast/0","type":"type"},{"doc":"","ref":"SquidWeb.Router.html#t:tentacle_app/0","title":"SquidWeb.Router.tentacle_app/0","type":"type"},{"doc":"Squid is a framework that helps you divide your application into multiple small contexts and/or applications called tentacles . Each tentacle defines its own logic (router, live view ...).","ref":"readme.html","title":"Squid","type":"extras"},{"doc":"This framework is in development and isn't fully ready for production yet. def deps do [ { :squid , git : &quot;https://github.com/drakkardigital/squid&quot; , tag : &quot;0.3.0&quot; } , ] end","ref":"readme.html#installation","title":"Squid - Installation","type":"extras"},{"doc":"# config/config.exs config :squid , tentacles : [ :tentacle_a , :tentacle_b ] # apps/tentacle_a/config/config.exs config :tentacle_a , :squid , router : Tentacle1Web.Router # apps/tentacle_b/config/config.exs config :tentacle_b , :squid , router : Tentacle2Web.Router Learn more about SquidWeb.Router . Then create the dynamic router with the following code. defmodule YourHeadApp do use Application def start ( _type , args ) do # The next line is REALLY important SquidWeb . create_dynamic_router ( ) children = [ ] Supervisor . start_link ( children , strategy : :one_for_one ) end end Learn more about squid routing system on the SquidWeb.Router module.","ref":"readme.html#headrouter","title":"Squid - HeadRouter","type":"extras"},{"doc":"One of the major feature of Squid is to construct partials using your tentacles configurations. This is really usefull for building a menu or any composed view. # in apps/tentacle_a/config/config.exs config :tentacle_a , :squid , partials : %{ greetings_builder : { TentacleA.Greetings , priority : 1 } } # in apps/tentacle_a/lib/tentacle_a_web/greetings.ex defmodule TentacleA.Greetings do @behaviour SquidWeb.Partial def render ( assigns ) do ~H&quot;&quot;&quot; &lt;div&gt;Hello &lt;%= @user_name %&gt; from tentacle A&lt;/div&gt; &quot;&quot;&quot; end end # in apps/tentacle_b/config/config.exs config :tentacle_b , :squid , partial : %{ greetings_builder : { TentacleB.Greetings , priority : 2 } } # in apps/tentacle_b/lib/tentacle_b_web/greetings.ex defmodule TentacleB.Greetings do @behaviour SquidWeb.Partial def render ( assigns ) , do : ~H&quot;&quot;&quot; &lt;div&gt;Hello &lt;%= @user_name %&gt; from tentacle B&lt;/div&gt; &quot;&quot;&quot; end end You could then generate this partial view using the following code &lt; SquidWeb.Partial . render partial = { :greetings_builder } user_name = &quot;Squid&#39;s King&quot; / &gt; &lt;div&gt;Hello Squid's King from tentacle B&lt;/div&gt; &lt;div&gt;Hello Squid's King from tentacle A&lt;/div&gt; Learn more about squid partials system on the SquidWeb.Partial module.","ref":"readme.html#partials","title":"Squid - Partials","type":"extras"}]